//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%39942D770016.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%39942D770016.cm

//## begin module%39942D770016.cp preserve=no
//## end module%39942D770016.cp

//## Module: Background%39942D770016; Package specification
//## Subsystem: XSModel::Data::BackCorr%39942CF3002B
//## Source file: /data/veris5/millerj/headas/Xspec/src/XSModel/Data/BackCorr/Background.h

#ifndef BACKGROUND_H
#define BACKGROUND_H 1

//## begin module%39942D770016.additionalIncludes preserve=no
//## end module%39942D770016.additionalIncludes

//## begin module%39942D770016.includes preserve=yes
//## end module%39942D770016.includes

// Error
#include <XSUtil/Error/Error.h>
// XspecRegistry
#include <XSModel/DataFactory/XspecRegistry.h>

class SpectralData;
class DataSet;

//## begin module%39942D770016.declarations preserve=no
//## end module%39942D770016.declarations

//## begin module%39942D770016.additionalDeclarations preserve=yes
#include "xsTypes.h"
//## end module%39942D770016.additionalDeclarations


//## begin BackCorr%366ED6415D68.preface preserve=yes
//## end BackCorr%366ED6415D68.preface

//## Class: BackCorr%366ED6415D68; private
//	Class representing the background for the dataset
//## Category: XSModel::Data::BackCorr%39942D5A033F
//## Subsystem: XSModel::Data::BackCorr%39942CF3002B
//## Persistence: Transient
//## Cardinality/Multiplicity: n



//## Uses: <unnamed>%39F8645D0068;SpectralData { -> F}

class BackCorr : public RegisteredFormat  //## Inherits: <unnamed>%39A3D80F022E
{
  //## begin BackCorr%366ED6415D68.initialDeclarations preserve=yes
  //## end BackCorr%366ED6415D68.initialDeclarations

  public:
    //## Class: IncorrectGrouping%39F86F06020B
    //## Category: XSModel::Data::BackCorr%39942D5A033F
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class IncorrectGrouping : public YellowAlert  //## Inherits: <unnamed>%39F8706F02EC
    {
      public:
        //## Constructors (specified)
          //## Operation: IncorrectGrouping%39F8709202CA
          IncorrectGrouping (const string& message = string());

      protected:
      private:
      private: //## implementation
    };

    //## Constructors (generated)
      BackCorr();

    //## Destructor (generated)
      virtual ~BackCorr();


    //## Other Operations (specified)
      //## Operation: destroy%39C136A202DC
      //## Exceptions: ()
      void destroy () throw ();

      //## Operation: clone%39C13C52039B
      virtual BackCorr* clone () const = 0;

      //## Operation: setData%3A2BB7590048
      void setData (size_t spectrumNumber, size_t backgrndRow, bool correction = false);

      //## Operation: read%3A2BFDB50001
      virtual size_t read (const string& fileName, bool readFlag = true) = 0;

      //## Operation: data%3A2E8A3A02EA
      const SpectralData* data () const;

      //## Operation: closeSourceFiles%3A39408802A0
      virtual void closeSourceFiles () = 0;

      //## Operation: renumber%3A75DC4400E0
      void renumber (size_t newIndex);

      //## Operation: weightVariance%3D46FE47028F
      void weightVariance (const RealArray& norm, bool correction);

      //## Operation: initialize%3D3C345100D6
      virtual void initialize (DataSet* parentData, size_t parentRow, const string& fileName, size_t backCorRow) = 0;

      //## Operation: spectrum%3D46CB24033F
      const RealArray& spectrum () const;

      //## Operation: variance%3D46CB510310
      const RealArray& variance () const;

      //## Operation: setSpectrum%3D46F772016E
      void setSpectrum (const RealArray& value);

      //## Operation: setVariance%3D46F7AB0213
      void setVariance (const RealArray& value);

      //## Operation: setRawVariance%3D4ECA1400B5
      void setRawVariance (const RealArray& value);

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: aScaleIsKeyword%3F7D8FC301FE
      bool aScaleIsKeyword () const;
      void aScaleIsKeyword (bool value);

      //## Attribute: bScaleIsKeyword%3F7D8FE402DC
      bool bScaleIsKeyword () const;
      void bScaleIsKeyword (bool value);

      //## Attribute: runPath%41A216A6028F
      const string& runPath () const;
      void runPath (const string& value);

    //## Get and Set Operations for Associations (generated)

      //## Association: XSModel::Data::<unnamed>%39F865D4031F
      //## Role: BackCorr::data%39F865D70028
      SpectralData* data ();
      void data (SpectralData* value);

  public:
    // Additional Public Declarations
      //## begin BackCorr%366ED6415D68.public preserve=yes
      //## end BackCorr%366ED6415D68.public

  protected:
    //## Constructors (generated)
      BackCorr(const BackCorr &right);

    //## Assignment Operation (generated)
      BackCorr & operator=(const BackCorr &right);


    //## Other Operations (specified)
      //## Operation: setArrays%3A2BC37100CA
      virtual void setArrays (size_t backgrndRow, bool ignoreStats = false) = 0;

      //## Operation: setDescription%3A2BC3860310
      virtual void setDescription (size_t spectrumNumber) = 0;

      //## Operation: scaleArrays%3A2BC38B03B7
      virtual void scaleArrays (bool correction = false);

      //## Operation: isCounts%3A366F5B0072
      virtual bool isCounts () const;

      //## Operation: Swap%3A9582C8007F
      virtual void Swap (BackCorr& right);

      //## Operation: groupArrays%3C51A8F40367
      virtual void groupArrays (bool correction);

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: sourceRow%3D2F10BE02E6
      size_t sourceRow ();
      void sourceRow (size_t value);

    //## Get and Set Operations for Associations (generated)

      //## Association: XSModel::Data::BackCorr::<unnamed>%3AAD3B140048
      //## Role: BackCorr::source%3AAD3B1402BC
      DataSet* source ();
      void source (DataSet* value);

    // Additional Protected Declarations
      //## begin BackCorr%366ED6415D68.protected preserve=yes
      //## end BackCorr%366ED6415D68.protected

  private:

    //## Other Operations (specified)
      //## Operation: copy%3A9582960312
      virtual void copy (const BackCorr& right) = 0;

    // Additional Private Declarations
      //## begin BackCorr%366ED6415D68.private preserve=yes
      //## end BackCorr%366ED6415D68.private

  private: //## implementation
    // Data Members for Class Attributes

      //## begin BackCorr::sourceRow%3D2F10BE02E6.attr preserve=no  protected: size_t {U} 0
      size_t m_sourceRow;
      //## end BackCorr::sourceRow%3D2F10BE02E6.attr

      //## begin BackCorr::aScaleIsKeyword%3F7D8FC301FE.attr preserve=no  public: bool {U} 
      bool m_aScaleIsKeyword;
      //## end BackCorr::aScaleIsKeyword%3F7D8FC301FE.attr

      //## begin BackCorr::bScaleIsKeyword%3F7D8FE402DC.attr preserve=no  public: bool {U} 
      bool m_bScaleIsKeyword;
      //## end BackCorr::bScaleIsKeyword%3F7D8FE402DC.attr

      //## begin BackCorr::runPath%41A216A6028F.attr preserve=no  public: string {U} 
      string m_runPath;
      //## end BackCorr::runPath%41A216A6028F.attr

    // Data Members for Associations

      //## Association: XSModel::Data::<unnamed>%39F865D4031F
      //## begin BackCorr::data%39F865D70028.role preserve=no  public: SpectralData { -> 1RFHgN}
      SpectralData* m_data;
      //## end BackCorr::data%39F865D70028.role

      //## Association: XSModel::Data::BackCorr::<unnamed>%3AAD3B140048
      //## begin BackCorr::source%3AAD3B1402BC.role preserve=no  protected: DataSet { -> 1RFHgN}
      DataSet* m_source;
      //## end BackCorr::source%3AAD3B1402BC.role

    // Additional Implementation Declarations
      //## begin BackCorr%366ED6415D68.implementation preserve=yes
      //## end BackCorr%366ED6415D68.implementation

};

//## begin BackCorr%366ED6415D68.postscript preserve=yes
//## end BackCorr%366ED6415D68.postscript

//## begin Background%39F856B50022.preface preserve=yes
//## end Background%39F856B50022.preface

//## Class: Background%39F856B50022
//## Category: XSModel::Data::BackCorr%39942D5A033F
//## Subsystem: XSModel::Data::BackCorr%39942CF3002B
//## Persistence: Transient
//## Cardinality/Multiplicity: n



//## Uses: <unnamed>%3A084B3700F2;BackCorr { -> }

typedef BackCorr Background;

//## begin Background%39F856B50022.postscript preserve=yes
//## end Background%39F856B50022.postscript

//## begin Correction%39F858250129.preface preserve=yes
//## end Correction%39F858250129.preface

//## Class: Correction%39F858250129
//## Category: XSModel::Data::BackCorr%39942D5A033F
//## Subsystem: XSModel::Data::BackCorr%39942CF3002B
//## Persistence: Transient
//## Cardinality/Multiplicity: n



//## Uses: <unnamed>%3A084B3A0172;BackCorr { -> }

typedef BackCorr Correction;

//## begin Correction%39F858250129.postscript preserve=yes
//## end Correction%39F858250129.postscript

// Class BackCorr::IncorrectGrouping 

// Class BackCorr 


//## Other Operations (inline)
inline const SpectralData* BackCorr::data () const
{
  return m_data;

  //## begin BackCorr::data%3A2E8A3A02EA.body preserve=yes
  //## end BackCorr::data%3A2E8A3A02EA.body
}

//## Get and Set Operations for Class Attributes (inline)

inline size_t BackCorr::sourceRow ()
{
  //## begin BackCorr::sourceRow%3D2F10BE02E6.get preserve=no
  return m_sourceRow;
  //## end BackCorr::sourceRow%3D2F10BE02E6.get
}

inline void BackCorr::sourceRow (size_t value)
{
  //## begin BackCorr::sourceRow%3D2F10BE02E6.set preserve=no
  m_sourceRow = value;
  //## end BackCorr::sourceRow%3D2F10BE02E6.set
}

inline bool BackCorr::aScaleIsKeyword () const
{
  //## begin BackCorr::aScaleIsKeyword%3F7D8FC301FE.get preserve=no
  return m_aScaleIsKeyword;
  //## end BackCorr::aScaleIsKeyword%3F7D8FC301FE.get
}

inline void BackCorr::aScaleIsKeyword (bool value)
{
  //## begin BackCorr::aScaleIsKeyword%3F7D8FC301FE.set preserve=no
  m_aScaleIsKeyword = value;
  //## end BackCorr::aScaleIsKeyword%3F7D8FC301FE.set
}

inline bool BackCorr::bScaleIsKeyword () const
{
  //## begin BackCorr::bScaleIsKeyword%3F7D8FE402DC.get preserve=no
  return m_bScaleIsKeyword;
  //## end BackCorr::bScaleIsKeyword%3F7D8FE402DC.get
}

inline void BackCorr::bScaleIsKeyword (bool value)
{
  //## begin BackCorr::bScaleIsKeyword%3F7D8FE402DC.set preserve=no
  m_bScaleIsKeyword = value;
  //## end BackCorr::bScaleIsKeyword%3F7D8FE402DC.set
}

inline const string& BackCorr::runPath () const
{
  //## begin BackCorr::runPath%41A216A6028F.get preserve=no
  return m_runPath;
  //## end BackCorr::runPath%41A216A6028F.get
}

inline void BackCorr::runPath (const string& value)
{
  //## begin BackCorr::runPath%41A216A6028F.set preserve=no
  m_runPath = value;
  //## end BackCorr::runPath%41A216A6028F.set
}

//## Get and Set Operations for Associations (inline)

inline SpectralData* BackCorr::data ()
{
  //## begin BackCorr::data%39F865D70028.get preserve=no
  return m_data;
  //## end BackCorr::data%39F865D70028.get
}

inline void BackCorr::data (SpectralData* value)
{
  //## begin BackCorr::data%39F865D70028.set preserve=no
  m_data = value;
  //## end BackCorr::data%39F865D70028.set
}

inline DataSet* BackCorr::source ()
{
  //## begin BackCorr::source%3AAD3B1402BC.get preserve=no
  return m_source;
  //## end BackCorr::source%3AAD3B1402BC.get
}

inline void BackCorr::source (DataSet* value)
{
  //## begin BackCorr::source%3AAD3B1402BC.set preserve=no
  m_source = value;
  //## end BackCorr::source%3AAD3B1402BC.set
}

//## begin module%39942D770016.epilog preserve=yes
//## end module%39942D770016.epilog


#endif
